## mingw-w64-freecad-1.0.0-1.src.tar.zst

=== CMakeLists.txt ===
# As of January 2023 we require CMake 3.16.3
# see https://forum.freecad.org/viewtopic.php?f=10&t=72173
# for further info why
cmake_minimum_required(VERSION 3.16.3 FATAL_ERROR)

# policy CMP0072 was introduced with CMake 3.11
# relates to FindOpenGL module
# and cache variables OPENGL_gl_LIBRARY, OPENGL_glu_LIBRARY
if (POLICY CMP0072)
    set(OpenGL_GL_PREFERENCE LEGACY)
endif(POLICY CMP0072)

# FindPythonInterp and FindPythonLibs modules are deprecated.
# Currently, they are still used by shiboken's CMake files
if (POLICY CMP0148)
    cmake_policy(SET CMP0148 OLD)
endif()

option(FREECAD_USE_CCACHE "Auto detect and use ccache during compilation" ON)

if(FREECAD_USE_CCACHE)
    find_program(CCACHE_PROGRAM ccache)  #This check should occur before project()
    if(CCACHE_PROGRAM)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
    endif()
endif()

project(FreeCAD)

set(PACKAGE_VERSION_MAJOR "1")
set(PACKAGE_VERSION_MINOR "0")
set(PACKAGE_VERSION_PATCH "0") # number of patch release (e.g. "4" for the 0.18.4 release)
set(PACKAGE_VERSION_SUFFIX "") # either "dev" for development snapshot or "" (empty string)
set(PACKAGE_BUILD_VERSION "0") # used when the same FreeCAD version will be re-released (for example using an updated LibPack)

set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}")
set(PACKAGE_STRING "${PROJECT_NAME} ${PACKAGE_VERSION}")

# include local modules
include(CheckCXXCompilerFlag)
include(AddFileDependencies)
include(cMake/FreeCadMacros.cmake)
# include helper functions/macros
add_subdirectory(cMake/FreeCAD_Helpers)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

CompilerChecksAndSetups()
ConfigureCMakeVariables()
InitializeFreeCADBuildOptions()
CheckInterModuleDependencies()
FreeCADLibpackChecks()
SetupDoxygen()
SetupLibFmt()
SetupYamlCpp()
if(NOT FREECAD_LIBPACK_USE OR FREECAD_LIBPACK_CHECKFILE_CLBUNDLER OR FREECAD_LIBPACK_CHECKFILE_VERSION)
    SetupPython()
    SetupPCL()
    SetupPybind11()
    SetupXercesC()
    find_package(ZLIB REQUIRED)
    find_package(PyCXX REQUIRED)
    SetupOpenCasCade()
    if(BUILD_GUI)
        # Do this before the check for SMESH because it depends on vtk
        # that may have its own OpenGL check but possibly fails and leaves
        # OPENGL_gl_LIBRARY empty that results into linker errors
        SetupOpenGL()
    endif(BUILD_GUI)
    SetupBoost()
    SetupSalomeSMESH()
    if (BUILD_FEM_NETGEN)
        find_package(NETGEN)
    endif(BUILD_FEM_NETGEN)
    # not needed at the moment
    #find_package(OpenCV REQUIRED)
    SetupSwig()
    SetupEigen()
    # This file is included directly due to some cMake macros that are defined within.
    # If these macro definitions are embedded within another macro, it causes problems.
    include(cMake/FreeCAD_Helpers/SetupQt.cmake)
    SetupFreetype()

    if(BUILD_GUI)
        SetupCoin3D()
        SetupSpaceball()
        SetupShibokenAndPyside()
        SetupMatplotlib()
    endif(BUILD_GUI)
endif()

if(BUILD_VR)
    find_package(Rift)
endif(BUILD_VR)

SetLibraryVersions()
SetGlobalCompilerAndLinkerSettings()

add_subdirectory(src)
add_subdirectory(data)

BuildAndInstallDesignerPlugin()

CreatePackagingTargets()

if(MSVC AND FREECAD_LIBPACK_USE AND LIBPACK_FOUND)
    CopyLibpackDirectories()
endif()

if (ENABLE_DEVELOPER_TESTS)
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
endif()

PrintFinalReport()

message("\n=================================================\n"
        "Now run 'cmake --build ${CMAKE_BINARY_DIR}' to build ${PROJECT_NAME}\n"
        "=================================================\n")

=== OndselSolver/CMakeLists.txt ===
if ( ONDSELSOLVER_BUILD_SHARED )
    message( STATUS "[OndselSolver] Building shared library" )
    add_library(OndselSolver SHARED)
else()
    message( STATUS "[OndselSolver] Building static library" )
    add_library(OndselSolver STATIC)
endif()

set(ONDSELSOLVER_SRC
        Abs.cpp
        AbsConstraint.cpp
        AccICKineNewtonRaphson.cpp
        AccICNewtonRaphson.cpp
        AccKineNewtonRaphson.cpp
        AccNewtonRaphson.cpp
        AllowZRotation.cpp
        AllowZRotationConstraintIqctJqc.cpp
        AngleJoint.cpp
        AngleZConstraintIJ.cpp
        AngleZConstraintIqcJc.cpp
        AngleZConstraintIqcJqc.cpp
        AngleZIecJec.cpp
        AngleZIeqcJec.cpp
        AngleZIeqcJeqc.cpp
        AnyGeneralSpline.cpp
        AnyPosICNewtonRaphson.cpp
        ArcSine.cpp
        ArcTan.cpp
        ArcTan2.cpp
        Arguments.cpp
        Array.cpp
        ASMTAllowRotation.cpp
        ASMTAngleJoint.cpp
        ASMTAnimationParameters.cpp
        ASMTAssembly.cpp
        ASMTConeConeContact.cpp
        ASMTContact.cpp
        ASMTCylConeContact.cpp
        ASMTCylCylContact.cpp
        ASMTCompoundJoint.cpp
        ASMTConstantGravity.cpp
        ASMTConstantVelocityJoint.cpp
        ASMTConstraintSet.cpp
        ASMTCylindricalJoint.cpp
        ASMTCylSphJoint.cpp
        ASMTExtrusion.cpp
        ASMTFixedJoint.cpp
        ASMTForceTorque.cpp
        ASMTGearJoint.cpp
        ASMTGeneralMotion.cpp
        ASMTInPlaneJoint.cpp
        ASMTItem.cpp
        ASMTItemIJ.cpp
        ASMTJoint.cpp
        ASMTKinematicIJ.cpp
        ASMTLimit.cpp
        ASMTLineInPlaneJoint.cpp
        ASMTMarker.cpp
        ASMTMotion.cpp
        ASMTNoRotationJoint.cpp
        ASMTParallelAxesJoint.cpp
        ASMTPart.cpp
        ASMTPerpendicularJoint.cpp
        ASMTPlanarJoint.cpp
        ASMTPointInLineJoint.cpp
        ASMTPointInPlaneJoint.cpp
        ASMTPrincipalMassMarker.cpp
        ASMTRackPinionJoint.cpp
        ASMTRefCurve.cpp
        ASMTRefItem.cpp
        ASMTRefPoint.cpp
        ASMTRefSurface.cpp
        ASMTRevCylJoint.cpp
        ASMTRevoluteJoint.cpp
        ASMTRevRevJoint.cpp
        ASMTRotationalMotion.cpp
        ASMTRotationLimit.cpp
        ASMTScrewJoint.cpp
        ASMTSimulationParameters.cpp
        ASMTSpatialContainer.cpp
        ASMTSpatialItem.cpp
        ASMTSphericalJoint.cpp
        ASMTSphSphJoint.cpp
        ASMTTime.cpp
        ASMTTranslationalJoint.cpp
        ASMTTranslationalMotion.cpp
        ASMTTranslationLimit.cpp
        ASMTUniversalJoint.cpp
        AtPointConstraintIJ.cpp
        AtPointConstraintIqcJc.cpp
        AtPointConstraintIqcJqc.cpp
        AtPointConstraintIqctJqc.cpp
        AtPointJoint.cpp
        BasicIntegrator.cpp
        BasicQuasiIntegrator.cpp
        BasicUserFunction.cpp
        CADSystem.cpp
        CartesianFrame.cpp
        CompoundJoint.cpp
        Constant.cpp
        ConstantGravity.cpp
        ConstantVelocityJoint.cpp
        Constraint.cpp
        ConstraintIJ.cpp
        ConstraintSet.cpp
        ConstVelConstraintIJ.cpp
        ConstVelConstraintIqcJc.cpp
        ConstVelConstraintIqcJqc.cpp
        Cosine.cpp
        CREATE.cpp
        CylindricalJoint.cpp
        CylSphJoint.cpp
        DiagonalMatrix.cpp
        DifferenceOperator.cpp
        DifferentiatedGeneralSpline.cpp
        DirectionCosineConstraintIJ.cpp
        DirectionCosineConstraintIqcJc.cpp
        DirectionCosineConstraintIqcJqc.cpp
        DirectionCosineConstraintIqctJqc.cpp
        DirectionCosineIecJec.cpp
        DirectionCosineIeqcJec.cpp
        DirectionCosineIeqcJeqc.cpp
        DirectionCosineIeqctJeqc.cpp
        DiscontinuityError.cpp
        DispCompIecJecIe.cpp
        DispCompIecJecKec.cpp
        DispCompIecJecKeqc.cpp
        DispCompIecJecO.cpp
        DispCompIeqcJecIe.cpp
        DispCompIeqcJecKeqc.cpp
        DispCompIeqcJecO.cpp
        DispCompIeqcJeqcIe.cpp
        DispCompIeqcJeqcKeqc.cpp
        DispCompIeqcJeqcKeqct.cpp
        DispCompIeqcJeqcO.cpp
        DispCompIeqctJeqcIe.cpp
        DispCompIeqctJeqcKeqct.cpp
        DispCompIeqctJeqcO.cpp
        DistanceConstraintIJ.cpp
        DistanceConstraintIqcJc.cpp
        DistanceConstraintIqcJqc.cpp
        DistanceConstraintIqctJqc.cpp
        DistancexyConstraintIJ.cpp
        DistancexyConstraintIqcJc.cpp
        DistancexyConstraintIqcJqc.cpp
        DistIecJec.cpp
        DistIeqcJec.cpp
        DistIeqcJeqc.cpp
        DistIeqctJeqc.cpp
        DistxyIecJec.cpp
        DistxyIeqcJec.cpp
        DistxyIeqcJeqc.cpp
        DistxyIeqctJeqc.cpp
        EigenDecomposition.cpp
        EndFramec.cpp
        EndFrameqc.cpp
        EndFrameqct.cpp
        EndFrameqct2.cpp
        EulerAngles.cpp
        EulerAnglesDDot.cpp
        EulerAnglesDot.cpp
        EulerAngleszxz.cpp
        EulerAngleszxzDDot.cpp
        EulerAngleszxzDot.cpp
        EulerArray.cpp
        EulerConstraint.cpp
        EulerParameters.cpp
        EulerParametersDDot.cpp
        EulerParametersDot.cpp
        Exponential.cpp
        ExpressionX.cpp
        ExternalSystem.cpp
        FixedJoint.cpp
        ForceTorqueData.cpp
        ForceTorqueItem.cpp
        FullColumn.cpp
        FullMatrix.cpp
        FullMotion.cpp
        FullRow.cpp
        FullVector.cpp
        Function.cpp
        FunctionFromData.cpp
        FunctionWithManyArgs.cpp
        FunctionX.cpp
        FunctionXcParameter.cpp
        FunctionXY.cpp
        GearConstraintIJ.cpp
        GearConstraintIqcJc.cpp
        GearConstraintIqcJqc.cpp
        GearJoint.cpp
        GEFullMat.cpp
        GEFullMatFullPv.cpp
        GEFullMatParPv.cpp
        GeneralSpline.cpp
        GESpMat.cpp
        GESpMatFullPv.cpp
        GESpMatFullPvPosIC.cpp
        GESpMatParPv.cpp
        GESpMatParPvMarko.cpp
        GESpMatParPvMarkoFast.cpp
        GESpMatParPvPrecise.cpp
        ICKineIntegrator.cpp
        IndependentVariable.cpp
        InLineJoint.cpp
        InPlaneJoint.cpp
        Integral.cpp
        Integrator.cpp
        IntegratorInterface.cpp
        Item.cpp
        ItemIJ.cpp
        Joint.cpp
        KineIntegrator.cpp
        KinematicIeJe.cpp
        LDUFullMat.cpp
        LDUFullMatParPv.cpp
        LDUSpMat.cpp
        LDUSpMatParPv.cpp
        LDUSpMatParPvMarko.cpp
        LDUSpMatParPvPrecise.cpp
        LimitIJ.cpp
        LinearMultiStepMethod.cpp
        LineInPlaneJoint.cpp
        Ln.cpp
        Log10.cpp
        LogN.cpp
        MarkerFrame.cpp
        MatrixDecomposition.cpp
        MatrixGaussElimination.cpp
        MatrixLDU.cpp
        MatrixSolver.cpp
        MaximumIterationError.cpp
        MbDMath.cpp
        MomentOfInertiaSolver.cpp
        Negative.cpp
        NewtonRaphson.cpp
        NewtonRaphsonError.cpp
        NoRotationJoint.cpp
        NotKinematicError.cpp
        Numeric.cpp
        OrbitAngleZIecJec.cpp
        OrbitAngleZIeqcJec.cpp
        OrbitAngleZIeqcJeqc.cpp
        Orientation.cpp
        ParallelAxesJoint.cpp
        Part.cpp
        PartFrame.cpp
        PerpendicularJoint.cpp
        PiecewiseFunction.cpp
        PlanarJoint.cpp
        PointInLineJoint.cpp
        PointInPlaneJoint.cpp
        Polynomial.cpp
        PosICDragLimitNewtonRaphson.cpp
        PosICDragNewtonRaphson.cpp
        PosICKineNewtonRaphson.cpp
        PosICNewtonRaphson.cpp
        PosKineNewtonRaphson.cpp
        PosNewtonRaphson.cpp
        PosVelAccData.cpp
        Power.cpp
        PrescribedMotion.cpp
        Product.cpp
        QuasiIntegrator.cpp
        RackPinConstraintIJ.cpp
        RackPinConstraintIqcJc.cpp
        RackPinConstraintIqcJqc.cpp
        RackPinJoint.cpp
        RampStepFunction.cpp
        Reciprocal.cpp
        RedundantConstraint.cpp
        RevCylJoint.cpp
        RevoluteJoint.cpp
        RevRevJoint.cpp
        RotationLimitIJ.cpp
        RowTypeMatrix.cpp
        ScalarNewtonRaphson.cpp
        ScrewConstraintIJ.cpp
        ScrewConstraintIqcJc.cpp
        ScrewConstraintIqcJqc.cpp
        ScrewJoint.cpp
        SimulationStoppingError.cpp
        Sine.cpp
        SingularMatrixError.cpp
        Solver.cpp
        SparseColumn.cpp
        SparseMatrix.cpp
        SparseRow.cpp
        SparseVector.cpp
        SphericalJoint.cpp
        SphSphJoint.cpp
        StableBackwardDifference.cpp
        StateData.cpp
        Sum.cpp
        Symbolic.cpp
        SymbolicParser.cpp
        SyntaxError.cpp
        System.cpp
        SystemNewtonRaphson.cpp
        SystemSolver.cpp
        SymTime.cpp
        TooManyTriesError.cpp
        TooSmallStepSizeError.cpp
        Translation.cpp
        TranslationalJoint.cpp
        TranslationConstraintIJ.cpp
        TranslationConstraintIqcJc.cpp
        TranslationConstraintIqcJqc.cpp
        TranslationConstraintIqctJqc.cpp
        TranslationLimitIJ.cpp
        Units.cpp
        UniversalJoint.cpp
        UserFunction.cpp
        Variable.cpp
        VectorNewtonRaphson.cpp
        VelICKineSolver.cpp
        VelICSolver.cpp
        VelKineSolver.cpp
        VelSolver.cpp
        ZRotation.cpp
        ZTranslation.cpp
)

set(ONDSELSOLVER_HEADERS
        Abs.h
        AbsConstraint.h
        AccICKineNewtonRaphson.h
        AccICNewtonRaphson.h
        AccKineNewtonRaphson.h
        AccNewtonRaphson.h
        AllowZRotation.h
        AllowZRotationConstraintIqctJqc.h
        AngleJoint.h
        AngleZConstraintIJ.h
        AngleZConstraintIqcJc.h
        AngleZConstraintIqcJqc.h
        AngleZIecJec.h
        AngleZIeqcJec.h
        AngleZIeqcJeqc.h
        AnyGeneralSpline.h
        AnyPosICNewtonRaphson.h
        ArcSine.h
        ArcTan.h
        ArcTan2.h
        Arguments.h
        Array.h
        ASMTAllowRotation.h
        ASMTAngleJoint.h
        ASMTAnimationParameters.h
        ASMTAssembly.h
        ASMTCompoundJoint.h
        ASMTConstantGravity.h
        ASMTConstantVelocityJoint.h
        ASMTConstraintSet.h
        ASMTCylindricalJoint.h
        ASMTCylSphJoint.h
        ASMTExtrusion.h
        ASMTFixedJoint.h
        ASMTForceTorque.h
        ASMTGearJoint.h
        ASMTGeneralMotion.h
        ASMTInPlaneJoint.h
        ASMTItem.h
        ASMTItemIJ.h
        ASMTJoint.h
        ASMTKinematicIJ.h
        ASMTLimit.h
        ASMTLineInPlaneJoint.h
        ASMTMarker.h
        ASMTMotion.h
        ASMTNoRotationJoint.h
        ASMTParallelAxesJoint.h
        ASMTPart.h
        ASMTPerpendicularJoint.h
        ASMTPlanarJoint.h
        ASMTPointInLineJoint.h
        ASMTPointInPlaneJoint.h
        ASMTPrincipalMassMarker.h
        ASMTRackPinionJoint.h
        ASMTRefCurve.h
        ASMTRefItem.h
        ASMTRefPoint.h
        ASMTRefSurface.h
        ASMTRevCylJoint.h
        ASMTRevoluteJoint.h
        ASMTRevRevJoint.h
        ASMTRotationalMotion.h
        ASMTRotationLimit.h
        ASMTScrewJoint.h
        ASMTSimulationParameters.h
        ASMTSpatialContainer.h
        ASMTSpatialItem.h
        ASMTSphericalJoint.h
        ASMTSphSphJoint.h
        ASMTTime.h
        ASMTTranslationalJoint.h
        ASMTTranslationalMotion.h
        ASMTTranslationLimit.h
        ASMTUniversalJoint.h
        AtPointConstraintIJ.h
        AtPointConstraintIqcJc.h
        AtPointConstraintIqcJqc.h
        AtPointConstraintIqctJqc.h
        AtPointJoint.h
        BasicIntegrator.h
        BasicQuasiIntegrator.h
        BasicUserFunction.h
        CADSystem.h
        CartesianFrame.h
        CompoundJoint.h
        ASMTConeConeContact.h
        ASMTContact.h
        ASMTCylConeContact.h
        ASMTCylCylContact.h
        Constant.h
        ConstantGravity.h
        ConstantVelocityJoint.h
        Constraint.h
        ConstraintIJ.h
        ConstraintSet.h
        ConstVelConstraintIJ.h
        ConstVelConstraintIqcJc.h
        ConstVelConstraintIqcJqc.h
        Cosine.h
        CREATE.h
        CylindricalJoint.h
        CylSphJoint.h
        DiagonalMatrix.h
        DifferenceOperator.h
        DifferentiatedGeneralSpline.h
        DirectionCosineConstraintIJ.h
        DirectionCosineConstraintIqcJc.h

=== src/Mod/Spreadsheet/App/CMakeLists.txt ===
if(WIN32)
    add_definitions(-DFCAppSpreadsheet)
endif(WIN32)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${PYTHON_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${XercesC_INCLUDE_DIRS}
)

set(Spreadsheet_LIBS
    FreeCADApp
)

set(Spreadsheet_SRCS
    Cell.cpp
    Cell.h
    DisplayUnit.h
    PreCompiled.cpp
    PreCompiled.h
    PropertySheet.cpp
    PropertySheet.h
    PropertySheetPy.xml
    PropertySheetPyImp.cpp
    PropertyColumnWidths.cpp
    PropertyColumnWidths.h
    PropertyColumnWidthsPy.xml
    PropertyColumnWidthsPyImp.cpp
    PropertyRowHeights.cpp
    PropertyRowHeights.h
    PropertyRowHeightsPy.xml
    PropertyRowHeightsPyImp.cpp
    Sheet.cpp
    Sheet.h
    SheetPy.xml
    SheetPyImp.cpp
    SheetObserver.cpp
    SheetObserver.h
    Utils.cpp
    Utils.h
    AppSpreadsheet.cpp
)

generate_from_xml(SheetPy)
generate_from_xml(PropertySheetPy)
generate_from_xml(PropertyColumnWidthsPy)
generate_from_xml(PropertyRowHeightsPy)

if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${Spreadsheet_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(Spreadsheet PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif(FREECAD_USE_PCH)

add_library(Spreadsheet SHARED ${Spreadsheet_SRCS})
target_link_libraries(Spreadsheet ${Spreadsheet_LIBS})
if (FREECAD_WARN_ERROR)
    target_compile_warn_error(Spreadsheet)
endif()


SET_BIN_DIR(Spreadsheet Spreadsheet /Mod/Spreadsheet)
SET_PYTHON_PREFIX_SUFFIX(Spreadsheet)

INSTALL(TARGETS Spreadsheet DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/Start/Gui/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-2.1-or-later
# /****************************************************************************
#  *                                                                          *
#  *   Copyright (c) 2024 The FreeCAD Project Association AISBL               *
#  *                                                                          *
#  *   This file is part of FreeCAD.                                          *
#  *                                                                          *
#  *   FreeCAD is free software: you can redistribute it and/or modify it     *
#  *   under the terms of the GNU Lesser General Public License as            *
#  *   published by the Free Software Foundation, either version 2.1 of the   *
#  *   License, or (at your option) any later version.                        *
#  *                                                                          *
#  *   FreeCAD is distributed in the hope that it will be useful, but         *
#  *   WITHOUT ANY WARRANTY; without even the implied warranty of             *
#  *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU       *
#  *   Lesser General Public License for more details.                        *
#  *                                                                          *
#  *   You should have received a copy of the GNU Lesser General Public       *
#  *   License along with FreeCAD. If not, see                                *
#  *   <https://www.gnu.org/licenses/>.                                       *
#  *                                                                          *
#  ***************************************************************************/

include_directories(
        ${CMAKE_CURRENT_BINARY_DIR}
        ${Boost_INCLUDE_DIRS}
        ${COIN3D_INCLUDE_DIRS}
        ${PYTHON_INCLUDE_DIRS}
        ${QtCore_INCLUDE_DIRS}
        ${QtSvg_INCLUDE_DIRS}
        ${QtUiTools_INCLUDE_DIRS}
        ${QtWidgets_INCLUDE_DIRS}
        ${XercesC_INCLUDE_DIRS}
        ${ZLIB_INCLUDE_DIR}
)

set(StartGui_LIBS
        Start
        FreeCADGui
        )

set(Start_TR_QRC ${CMAKE_CURRENT_BINARY_DIR}/Resources/Start_translation.qrc)
qt_find_and_add_translation(QM_SRCS "Resources/translations/*_*.ts"
        ${CMAKE_CURRENT_BINARY_DIR}/Resources/translations)
qt_create_resource_file(${Start_TR_QRC} ${QM_SRCS})
qt_add_resources(Start_QRC_SRCS Resources/Start.qrc ${Start_TR_QRC})
# qtquick_compiler_add_resources(Start_QRC_SRCS Resources/Start.qrc ${Start_TR_QRC} qml.qrc)

SET(StartGui_SRCS
        ${Start_QRC_SRCS}
        ${StartGui_UIC_SRCS}
        AppStartGui.cpp
        FileCardDelegate.cpp
        FileCardDelegate.h
        FileCardView.cpp
        FileCardView.h
        FirstStartWidget.cpp
        FirstStartWidget.h
        FlowLayout.cpp
        FlowLayout.h
        GeneralSettingsWidget.cpp
        GeneralSettingsWidget.h
        Manipulator.cpp
        Manipulator.h
        PreCompiled.cpp
        PreCompiled.h
        StartView.cpp
        StartView.h
        ThemeSelectorWidget.cpp
        ThemeSelectorWidget.h
        )

SET(StartGuiIcon_SVG
        Resources/icons/StartCommandIcon.svg
        Resources/icons/PartDesignWorkbench.svg
        )

SET(StartGuiThumbnail_PNG
        Resources/thumbnails/Theme_thumbnail_classic.png
        Resources/thumbnails/Theme_thumbnail_dark.png
        Resources/thumbnails/Theme_thumbnail_light.png
        )

# TODO: Evaluate PCH use with Qt6/QtQuick/Qml
if (FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${StartGui_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(StartGui PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif (FREECAD_USE_PCH)

# Add CoreFoundation to StartGui_LIBS on macOS
if (APPLE)
    find_library(COREFOUNDATION_LIBRARY CoreFoundation)
    if (COREFOUNDATION_LIBRARY)
        list(APPEND StartGui_LIBS ${COREFOUNDATION_LIBRARY})
    else()
        message(SEND_ERROR "CoreFoundation not found. Please ensure you're building on macOS.")
    endif()
endif()

add_library(StartGui SHARED ${StartGui_SRCS} ${StartGuiIcon_SVG} ${StartGuiThumbnail_PNG})
# target_link_libraries(StartGui ${StartGui_LIBS} Qt::Quick Qt::Qml Qt::QuickWidgets)
target_link_libraries(StartGui ${StartGui_LIBS})
if (FREECAD_WARN_ERROR)
    target_compile_warn_error(StartGui)
endif()

SET_BIN_DIR(StartGui StartGui /Mod/Start)
SET_PYTHON_PREFIX_SUFFIX(StartGui)

fc_copy_sources(StartGui "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Start" ${StartGuiIcon_SVG})

INSTALL(TARGETS StartGui DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${StartGuiIcon_SVG} DESTINATION "${CMAKE_INSTALL_DATADIR}/Mod/Start/Resources/icons")

=== tests/src/Mod/PartDesign/CMakeLists.txt ===

target_include_directories(PartDesign_tests_run PUBLIC
        ${EIGEN3_INCLUDE_DIR}
        ${OCC_INCLUDE_DIR}
        ${Python3_INCLUDE_DIRS}
        ${XercesC_INCLUDE_DIRS}
)

target_link_libraries(PartDesign_tests_run
        gtest_main
        ${Google_Tests_LIBS}
        PartDesign
)

add_subdirectory(App)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=freecad
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.0.0
pkgrel=1
_OS_commit=91f70382
pkgdesc="Free and Opensource multiplatform 3D parametric modeler (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://freecadweb.org/'
msys2_repository_url="https://github.com/FreeCAD/FreeCAD"
msys2_references=(
  'archlinux: freecad'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         "${MINGW_PACKAGE_PREFIX}-coin"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-med"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-opencascade"
         "${MINGW_PACKAGE_PREFIX}-openscad"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy"
         "${MINGW_PACKAGE_PREFIX}-python-packaging"
         "${MINGW_PACKAGE_PREFIX}-python-pivy"
         "${MINGW_PACKAGE_PREFIX}-pyside6"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-xerces-c"
         "${MINGW_PACKAGE_PREFIX}-vtk"
         "${MINGW_PACKAGE_PREFIX}-yaml-cpp"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-swig"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-microsoft-gsl"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
source=("https://github.com/FreeCAD/FreeCAD/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/Ondsel-Development/OndselSolver/archive/${_OS_commit}/OndselSolver-${_OS_commit}.tar.gz"
        "001-clang19-char-traits.patch")
sha256sums=('51115afd8e3b89f4bac343b986b0800d8e1c68fc1e322c3cd179cfe1033ef937'
            '061f651f503f1ec5a9814e174cdb8a9ba84d511a3b8be3d94852e84976c6b158'
            '0dcc9a5ce20f080913f2bff71f5e2eb7d166e789f1012cea2009f94c9f30e5f2')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  mv OndselSolver-*/* ${_realname}-${pkgver}/src/3rdParty/OndselSolver/

  cd ${_realname}-${pkgver}

  apply_patch_with_msg \
    001-clang19-char-traits.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CC} == clang ]]; then
    CXXFLAGS+=" -Wno-macro-redefined"
  else
    CXXFLAGS+=" -Wno-template-id-cdtor"
  fi

  CXXFLAGS+=" -Wno-deprecated-declarations -Wno-unknown-pragmas" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DFREECAD_QT_VERSION="6" \
      -DBUILD_TEST=OFF \
      -DBUILD_WEB=OFF \
      -DENABLE_DEVELOPER_TESTS=OFF \
      -DINSTALL_TO_SITEPACKAGES=OFF \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DPYTHON_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      "${_extra_config[@]}" \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  MSYS2_ARG_CONV_EXCL="-d" \
    python -m compileall -o 0 -o 1 -q -d"${MINGW_PREFIX}" "${pkgdir}${MINGW_PREFIX}"
}
